<?xml version="1.0"?>
<Unicens AsyncBandwidth="20" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="unicens.xsd">
  <!-- Head Unit -->
  <Node Address="0x200" Name="Head Unit">
    <SyncConnection MuteMode="NoMuting">
      <USBSocket EndpointAddress="0x1" FramesPerTransaction="42"/>
      <Splitter BytesPerFrame="12">
        <MOSTSocket Route="5.1 DVD Player Front" Offset="0" Bandwidth="4"/>
        <MOSTSocket Route="5.1 DVD Player Rear" Offset="4" Bandwidth="4"/>
        <MOSTSocket Route="5.1 DVD Player Effect" Offset="8" Bandwidth="4"/>
      </Splitter>
    </SyncConnection>
    <SyncConnection MuteMode="NoMuting">
        <MOSTSocket Bandwidth="2" Route="Route_NC_MIC_SOUT1" />
        <USBSocket EndpointAddress="0x81" FramesPerTransaction="256" />
    </SyncConnection>
	<SyncConnection MuteMode="NoMuting">
        <MOSTSocket Bandwidth="2" Route="Route_NC_MIC_SOUT2" />
        <USBSocket EndpointAddress="0x82" FramesPerTransaction="256" />
    </SyncConnection>
  </Node>

  <!-- Microphone Front-End -->
  <Node Address="0x520">
    <StreamPort ClockConfig="64Fs" DataAlignment="Seq" />
      <!-- Timberwolf Output -->
      <SyncConnection MuteMode="NoMuting">
        <StreamSocket StreamPinID="SRXA0" Bandwidth="8" />
        <Splitter BytesPerFrame="8">
          <MOSTSocket Route="Route_NC_MIC_SOUT1" Bandwidth="2" Offset="0" />
          <MOSTSocket Route="Route_NC_MIC_SOUT2" Bandwidth="2" Offset="4" />
        </Splitter>
      </SyncConnection>
      <SyncConnection MuteMode="NoMuting">
        <StreamSocket StreamPinID="SRXB0" Bandwidth="8" />
        <Splitter BytesPerFrame="8">
          <MOSTSocket Route="Route_Raw_Microphone1" Bandwidth="2" Offset="0" />
          <MOSTSocket Route="Route_Raw_Microphone2" Bandwidth="2" Offset="2" />
          <MOSTSocket Route="Route_Raw_Microphone3" Bandwidth="2" Offset="4" />
          <MOSTSocket Route="Route_Raw_Microphone4" Bandwidth="2" Offset="6" />
        </Splitter>
      </SyncConnection>
      <!-- Timberwolf Input -->
      <SyncConnection MuteMode="NoMuting">
        <Combiner BytesPerFrame="8">
          <MOSTSocket Bandwidth="4" Offset="0" Route="5.1 DVD Player Front" />
        </Combiner>
        <StreamSocket StreamPinID="SRXA1" Bandwidth="8" />
      </SyncConnection>
  </Node>

  <!-- Fiberdyne Amplifier -->
  <Node Address="0x510" Name="Fiberdyne Amplifier">
    <StreamPort ClockConfig="64Fs" DataAlignment="Seq"/>
    <SyncConnection MuteMode="NoMuting">
      <Combiner BytesPerFrame="8">
        <MOSTSocket Route="5.1 DVD Player Front" Bandwidth="4" Offset="0"/>
        <MOSTSocket Route="5.1 DVD Player Rear" Bandwidth="4" Offset="4"/>
      </Combiner>
      <StreamSocket StreamPinID="SRXA0" Bandwidth="8"/>
    </SyncConnection>
    <SyncConnection MuteMode="NoMuting">
      <MOSTSocket Route="5.1 DVD Player Effect" Bandwidth="4"/>
      <StreamSocket StreamPinID="SRXA1" Bandwidth="4"/>
    </SyncConnection>
  </Node>

  <!-- 1st Slim Amplifier -->
  <Node Address="0x270" Script="slim-amp-config" Name="1st Slim Amplifier">
    <StreamPort ClockConfig="64Fs" DataAlignment="Left16Bit"/>
    <SyncConnection MuteMode="NoMuting">
      <MOSTSocket Route="5.1 DVD Player Front" Bandwidth="4"/>
      <StreamSocket StreamPinID="SRXA0" Bandwidth="4"/>
    </SyncConnection>
  </Node>
  <!-- 2nd Slim Amplifier -->
  <Node Address="0x271" Script="slim-amp-config" Name="2nd Slim Amplifier">
    <StreamPort ClockConfig="64Fs" DataAlignment="Left16Bit"/>
    <SyncConnection MuteMode="NoMuting">
      <MOSTSocket Route="5.1 DVD Player Rear" Bandwidth="4"/>
      <StreamSocket StreamPinID="SRXA0" Bandwidth="4"/>
    </SyncConnection>
  </Node>
  <!-- 3rd Slim Amplifier -->
  <Node Address="0x272" Script="slim-amp-config" Name="3rd Slim Amplifier">
    <StreamPort ClockConfig="64Fs" DataAlignment="Left16Bit"/>
    <SyncConnection MuteMode="NoMuting">
      <MOSTSocket Route="5.1 DVD Player Effect" Bandwidth="4"/>
      <StreamSocket StreamPinID="SRXA0" Bandwidth="4"/>
    </SyncConnection>
  </Node>
  <Script Name="slim-amp-config">
    <I2CPortCreate Speed="FastMode"/>
    <I2CPortWrite Address="0x2A" Payload="1B 80"/>
    <I2CPortWrite Address="0x2A" Payload="11 B8"/>
    <I2CPortWrite Address="0x2A" Payload="12 60"/>
    <I2CPortWrite Address="0x2A" Payload="13 A0"/>
    <I2CPortWrite Address="0x2A" Payload="14 48"/>
    <I2CPortWrite Address="0x2A" Payload="20 00 89 77 72"/>
    <I2CPortWrite Address="0x2A" Payload="06 00"/>
    <I2CPortWrite Address="0x2A" Payload="05 00"/>
    <!-- Register 7: Master Volume (Max Volume=07 00 00 and Min Volume=07 03 FF) -->
    <!--   - together with "4a-hal-unicens" binding use "07 03 FF" = muted after start -->
    <!--   - otherwise use "07 01 50" = default volume -->
    <I2CPortWrite Address="0x2A" Payload="07 01 50"/>
  </Script>

  <!-- 1st Aux IO -->
  <Node Address="0x240" Script="aux-io-config" Name="1st Aux IO">
    <StreamPort ClockConfig="64Fs" DataAlignment="Left16Bit"/>
    <SyncConnection MuteMode="NoMuting">
      <MOSTSocket Route="5.1 DVD Player Front" Bandwidth="4"/>
      <StreamSocket StreamPinID="SRXA1" Bandwidth="4"/>
    </SyncConnection>
  </Node>
  <!-- 2nd Aux IO -->
  <Node Address="0x241" Script="aux-io-config" Name="2nd Aux IO">
    <StreamPort ClockConfig="64Fs" DataAlignment="Left16Bit"/>
    <SyncConnection MuteMode="NoMuting">
      <MOSTSocket Route="5.1 DVD Player Rear" Bandwidth="4"/>
      <StreamSocket StreamPinID="SRXA1" Bandwidth="4"/>
    </SyncConnection>
  </Node>
  <!-- 3rd Aux IO -->
  <Node Address="0x242" Script="aux-io-config" Name="3rd Aux IO">
    <StreamPort ClockConfig="64Fs" DataAlignment="Left16Bit"/>
    <SyncConnection MuteMode="NoMuting">
      <MOSTSocket Route="5.1 DVD Player Effect" Bandwidth="4"/>
      <StreamSocket StreamPinID="SRXA1" Bandwidth="4"/>
    </SyncConnection>
  </Node>
  <!-- Script for Aux IO -->
  <Script Name="aux-io-config">
    <I2CPortCreate Speed="FastMode"/>
    <I2CPortWrite Mode="BurstMode" BlockCount="10" Address="0x18" Length="3" Timeout="100"
                  Payload="00 0f 02 01 00 00 02 a5 df 03 3f 3f 04 02 02 10 30 30 11 00 00 12 00 00 13 00 00 14 00 00"/>
    <I2CPortWrite Mode="BurstMode" BlockCount="4" Address="0x18" Length="3" Timeout="100"
                  Payload="20 00 00 21 00 00 22 00 00 23 00 00"/>
  </Script>
</Unicens>
